/*
 * localStored.sql
 * Rozdzia 9, Oracle10g. Programowanie w jzyku PL/SQL
 * Ron Hardman, Mike McLaughlin i Scott Urman
 *
 * Ten skrypt demonstruje podprogram lokalny w obrbie procedury skadowanej
 */

set serveroutput on

CREATE OR REPLACE PROCEDURE StoredProc AS
  /* Deklaracje lokalne, ktre obejmuj kursor, zmienn i 
     funkcj */
     
  CURSOR c_SomeAuthors IS
    SELECT first_name, last_name
      FROM authors
      WHERE last_name > 'L'
      ORDER BY last_name;

  v_FormattedName VARCHAR2(50);

  /* Funkcja zwracajca imi i nazwisko
     rozdzielone odstpem */
  FUNCTION FormatName(p_FirstName IN VARCHAR2,
                      p_LastName IN VARCHAR2)
    RETURN VARCHAR2 IS
  BEGIN
    RETURN p_FirstName || ' ' || p_LastName;
  END FormatName;

-- Pocztek bloku gwnego
BEGIN
  FOR v_AuthorRecord IN c_SomeAuthors LOOP
    v_FormattedName := FormatName(v_AuthorRecord.first_name,
                                   v_AuthorRecord.last_name);
    DBMS_OUTPUT.PUT_LINE(v_FormattedName);
  END LOOP;
END StoredProc;
/

BEGIN
  StoredProc;
END;
/
